//***************************************************************************//
//* libtrivia: various little routines for C++                              *//
//* rng: random number generator wrapper                                    *//
//* (C) Joachim Wuttke, Antti Soininen 2001, 2012, 2013                     *//
//* http://apps.jcns.fz-juelich.de                                          *//
//***************************************************************************//

#ifndef TRIVIA_RNG_H
#define TRIVIA_RNG_H

namespace triv {
    class RandomNumberGenerator {
    public:
        //! Initialize with given seed.
        RandomNumberGenerator();
        ~RandomNumberGenerator();
        void reseed( unsigned long seed );
        void reseed_from_clock();
        double uniform();
        double uniform( const double rmin, const double rmax );
        double gaussian( const double stdv, const double cutoff=0 );
        double cauchy( const double width, const double cutoff=0 );
    private:
        class RandomNumberImplementation* pimpl;
    };
}

#endif // TRIVIA_RNG_H
